-- name: \\#DF7126\\[CS] CT's OC Pack
-- description: The one and only CT Himself, along with a bunch of characters I barely use.

--[[
    API Documentation for Character Select can be found below:
    https://github.com/Squishy6094/character-select-coop/blob/main/API-doc.md

    LONG LIVE SQUIMSHY!!!

    Use this if you're curious on how anything here works >v<
]]

local E_MODEL_CTH = smlua_model_util_get_id("cth_geo")
local E_MODEL_NEWCTH = smlua_model_util_get_id("newcth_geo")
local E_MODEL_MVIL = smlua_model_util_get_id("mvil_geo")
local E_MODEL_PMAN = smlua_model_util_get_id("pman_geo")

local TEX_CTH = get_texture_info("cth-icon")
local TEX_NEWCTH = get_texture_info("newcth-icon")
local TEX_MVIL = get_texture_info("mvil-icon")
local TEX_PMAN = get_texture_info("pman-icon")

local TEXT_MOD_NAME = "CT's OC Pack"

local VOICETABLE_NEWCTH = {
    [CHAR_SOUND_ATTACKED] = 'CT_Attacked.ogg',
    [CHAR_SOUND_DOH] = 'CT_Doh.ogg',
    [CHAR_SOUND_DROWNING] = 'CT_Drowning.ogg',
    [CHAR_SOUND_DYING] = 'CT_Dying.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'CT_WahGroundPound.ogg',
    [CHAR_SOUND_HAHA] = 'CT_Haha1.ogg',
    [CHAR_SOUND_HAHA_2] = 'CT_haha2.ogg',
    [CHAR_SOUND_HRMM] = 'CT_pickup.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'CT_HereWeGo.ogg',
    [CHAR_SOUND_HOOHOO] = 'CT_Hoohoo.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'CT_Mamamia.ogg',
    [CHAR_SOUND_OKEY_DOKEY] = 'CT_OkeyDokey.ogg',
    [CHAR_SOUND_ON_FIRE] = 'CT_OnFire.ogg',
    [CHAR_SOUND_OOOF] = 'CT_Oof1.ogg',
    [CHAR_SOUND_OOOF2] = 'CT_Oof2.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'CT_Hoo.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'CT_WahPunch.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'CT_YahPunch.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'CT_SoLongKingBowser.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'CT_Boing.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'CT_OnFire.ogg',
    [CHAR_SOUND_WAH2] = 'CT_Wah2.ogg',
    [CHAR_SOUND_WHOA] = 'CT_Whoa.ogg',
    [CHAR_SOUND_YAHOO] = 'CT_Yipee.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = 'CT_Yipee.ogg',
    [CHAR_SOUND_YAH_WAH_HOO] = 'CT_YahPunch.ogg',
    [CHAR_SOUND_YAWNING] = 'CT_Yawn.ogg',
}

local PALETTE_CTH = {
    [PANTS]  = { r = 0x60, g = 0x36, b = 0x00 },
    [SHIRT]  = { r = 0xFF, g = 0x74, b = 0x00 },
    [GLOVES] = { r = 0xEE, g = 0xC3, b = 0x9A },
    [SHOES]  = { r = 0xFF, g = 0xFF, b = 0xFF },
    [HAIR]   = { r = 0x00, g = 0x00, b = 0x00 },
    [SKIN]   = { r = 0xEE, g = 0xC3, b = 0x9A },
    [CAP]    = { r = 0xFF, g = 0x74, b = 0x00 },
    [EMBLEM] = { r = 0xFF, g = 0x74, b = 0x00 }
}

local PALETTE_NEWCTH = {
    [PANTS]  = { r = 0x60, g = 0x36, b = 0x00 },
    [SHIRT]  = { r = 0xFF, g = 0x74, b = 0x00 },
    [GLOVES] = { r = 0xEE, g = 0xC3, b = 0x9A },
    [SHOES]  = { r = 0xFF, g = 0xFF, b = 0xFF },
    [HAIR]   = { r = 0x00, g = 0x00, b = 0x00 },
    [SKIN]   = { r = 0xEE, g = 0xC3, b = 0x9A },
    [CAP]    = { r = 0xFF, g = 0x74, b = 0x00 },
    [EMBLEM] = { r = 0xFF, g = 0x74, b = 0x00 }
}

local PALETTE_MVIL = {
    [PANTS]  = { r = 0x3F, g = 0x3F, b = 0x74 },
    [SHIRT]  = { r = 0xD9, g = 0x57, b = 0x63 },
    [GLOVES] = { r = 0xEE, g = 0xC3, b = 0x9A },
    [SHOES]  = { r = 0x22, g = 0x20, b = 0x34 },
    [HAIR]   = { r = 0x22, g = 0x20, b = 0x34 },
    [SKIN]   = { r = 0xEE, g = 0xC3, b = 0x9A },
    [CAP]    = { r = 0xD9, g = 0x57, b = 0x63 },
    [EMBLEM] = { r = 0xD9, g = 0x57, b = 0x63 }
}


if _G.charSelectExists then
    CT_CTH = _G.charSelect.character_add("CT Himself", {"The gross old model that got lots of backlash"}, "CT Himself", {r = 223, g = 113, b = 38}, E_MODEL_CTH, CT_MARIO, TEX_CTH)
    _G.charSelect.character_add_palette_preset(E_MODEL_CTH, PALETTE_CTH)

CT_NEWCTH = _G.charSelect.character_add("CT Himself (Revamped)", {"As seen in the Herd CS"}, "CT Himself", {r = 223, g = 113, b = 38}, E_MODEL_NEWCTH, CT_MARIO, TEX_NEWCTH)
_G.charSelect.character_add_palette_preset(E_MODEL_NEWCTH, PALETTE_NEWCTH)

    CT_MVIL = _G.charSelect.character_add("Mr.Villain", {"Also goes by Michael V. Layne", "Owner of Villain's Pizza Pies"}, "CT Himself", {r = 217, g = 87, b = 99}, E_MODEL_MVIL, CT_MARIO, TEX_MVIL)
    _G.charSelect.character_add_palette_preset(E_MODEL_MVIL, PALETTE_MVIL)

    CT_PMAN = _G.charSelect.character_add("Pudding Man", {"Mascot of the hit pudding company Pudd-o"}, "CT Himself", {r = 155, g = 76, b = 1}, E_MODEL_PMAN, CT_MARIO, TEX_PMAN)

                    -- the following must be hooked for each character added
        _G.charSelect.character_add_voice(E_MODEL_NEWCTH, VOICETABLE_NEWCTH)
        hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
            if _G.charSelect.character_get_voice(m) == VOICETABLE_NEWCTH then return _G.charSelect.voice.sound(m, sound) end
        end)
        hook_event(HOOK_MARIO_UPDATE, function (m)
            if _G.charSelect.character_get_voice(m) == VOICETABLE_NEWCTH then return _G.charSelect.voice.snore(m) end
        end)

                            -- the following must be hooked for each character added
        _G.charSelect.character_add_voice(E_MODEL_CTH, VOICETABLE_NEWCTH)
        hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
            if _G.charSelect.character_get_voice(m) == VOICETABLE_NEWCTH then return _G.charSelect.voice.sound(m, sound) end
        end)
        hook_event(HOOK_MARIO_UPDATE, function (m)
            if _G.charSelect.character_get_voice(m) == VOICETABLE_NEWCTH then return _G.charSelect.voice.snore(m) end
        end)


else
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
end